import socket
import time
import struct
import Zeroconf





class HMEConnection(object):
    
    def __init__(self, rfile, wfile):

        self.rfile = rfile
        self.wfile = wfile
        self.f = wfile

        print "HEADER", repr(rfile.read(8))
        wfile.write('SBTV\x00\x00\x00(')
        wfile.flush()



    def send(self, fmt, *args):

        data = [ ]

        for code, arg in zip(fmt, args):


            if code == 'v':

                val = arg

                if val < 0:
                    val = -val
                    sign = 64
                else:
                    sign = 0

                while val > 63:
                    data.append(chr(val & 127))
                    val >>= 7

                data.append(chr(val | 128 | sign))

            elif code == 'b':
                data.append(chr(arg))

            elif code == 'd':
                data.append(arg)

        data = ''.join(data)

        while data:
            packlen = min(len(data), 65535)

            pack = data[:packlen]
            data = data[packlen:]

            self.f.write(struct.pack('!H', packlen))
            self.f.write(pack)

        self.f.write(struct.pack('!H', 0))
        self.f.flush()


    def rsrc_add_color(self, id, a, r, g, b):
        self.send('vvbbbb', 20, id, a, r, g, b)

    def rsrc_add_image(self, id, data):
        self.send('vvd', 24, id, data)

    def view_add(self, id, parent, x, y, w, h, visible):
        if visible:
            visible = 1
        else:
            visible = 0

        self.send('vvvvvvvb', 1, id, parent, x, y, w, h, visible)


    def view_set_visible(self, id, visible, animation=0):
        if visible:
            visible = 1
        else:
            visible = 0

        self.send('vvbv', 6, id, visible, animation)


    def view_set_resource(self, id, resource, flags=0):
        self.send('vvvv', 8, id, resource, flags)


    def process_input(self):
        while True:

            cs, = struct.unpack('!H', self.rfile.read(2))
            print "IN", cs, repr(self.rfile.read(cs))        


def respond(h):
    
    import sys
    # h.rsrc_add_image(3000, file(sys.argv[1]).read())
    h.rsrc_add_color(3000, 255, 192, 255, 0)
    h.view_add(3001, 2, 0, 0, 640, 480, 1)
    h.view_set_resource(3001, 3000, 0x4000)
    h.view_set_visible(2, 1)

    h.process_input()



zc = Zeroconf.Zeroconf()

# # Get local IP address
local_ip = socket.gethostbyname(socket.gethostname())
# print local_ip
local_ip = socket.inet_aton(local_ip)

svc1 = Zeroconf.ServiceInfo('_tivo-hme._tcp.local.',
                              'FooBar._tivo-hme._tcp.local.',
                              address = local_ip,
                              port = 12346,
                              weight = 0, priority=0,
                              properties = {
    'description': 'FooBar HME',
    'path' : '/foobar/',
    })

zc.registerService(svc1)



import BaseHTTPServer

class RequestHandler(BaseHTTPServer.BaseHTTPRequestHandler):

    def do_GET(self):

        print self.path

        if self.path != "/foobar/":
            self.send_error(404)
            return
            
        self.wfile.write('HTTP/1.0 200 Ok\r\n')
        self.wfile.write('Content-Type: application/x-hme\r\n')
        self.wfile.write("Set-Cookie: id=foobar; path=/; expires=Tue, 26-Apr-2022 19:00:00 GMT\r\n")
        self.wfile.write('\r\n')
        self.wfile.flush()

        h = HMEConnection(self.rfile, self.wfile)
        respond(h)





bhs = BaseHTTPServer.HTTPServer(('', 12346), RequestHandler)

try:
    bhs.serve_forever()
finally:
    zc.close()
    
